\\ Copyright 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


read("c-curve-defines.gp");

check_count = 0;
check_exact(got,want, name="") =
{
  check_count++;
  if(got!= want,
     print("\nwrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count));
}

\\-----------------------------------------------------------------------------

S_by_identity(k) =
{
  32106*S(k-16)
  +  31957*S(k-17)
  -  38005*S(k-18)
  +  26061*S(k-19)
  -  81222*S(k-20)
  + 101148*S(k-21)
  + 203936*S(k-22)
  + 131352*S(k-23)
  + 268080*S(k-24)
  - 268088*S(k-25);
}

S(25)
S_by_identity(25)

check_exact(vector(500,k,my(k=k+24); S_by_identity(k)), \
            vector(500,k,my(k=k+24); S(k)))

{
r =  32106 *2^-16
  +  31957 *2^-17
  +  26061 *2^-19
  + 101148 *2^-21
  + 203936 *2^-22
  + 131352 *2^-23
  + 268080 *2^-24;
}
r
r < 1