\\ Copyright 2014, 2015 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


\\ unexpanded
\\            0  1  2 3  4   5  6  7   8 9 10  11 12 13 14
left_perm  = [9, 3, 6,9,12,  3, 6,11,  0,2, 8,  0, 2, 1, 5 ];
right_perm = [8, 13,9,6, 2, 14, 6, 2, 10,3, 0,  7, 4, 3, 0 ];

mirror_perm = [ 0, 4,3,2,1, 7,6,5, 10,9,8, 14,13,12,11 ];

\\ following  WRONG
\\            0  1 2 3 4   5  6  7   8 9 10  11 12 13 14
left_perm  = [1, 1,5,0,2, 11, 6, 3,  8,2, 0,  9,12, 3, 6 ];
right_perm = [4, 3,0,7,4,  2, 6,14,  0,3,10,  6, 2,13, 9 ];


\\ \\ list is a sorted list.
\\ \\ Insert value into it, if not already present.
\\ listinsert_sorted(list,value) =
\\ {
\\   my(pos = setsearch(list,value,1));
\\   print(pos);
\\   if(pos, listinsert(list,value,pos));
\\   print(list);
\\ }
\\ {
\\   my(l=List([]));
\\   listinsert_sorted(l,3);
\\   print(l);
\\   Vec(l)==[3] || error("oops");
\\ }
\\ quit

\\ vector(#conf_initial_vector,i, conf_to_index(conf_initial_vector[i]));

my(pending=vector(2*size),
   pending_last = 0);
for(i=1,#conf_initial_vector,
   pending_last++;
   pending[pending_last] = conf_initial_vector[i]);
my(seen=vector(size));
while(pending_last > 0,
      \\ print("pending ",pending);
      my(conf       = pending[pending_last],
         conf_index = conf_to_index(conf));
      pending_last--;
      \\ print("conf ",conf_string(conf),"  ",conf_index);

      if(seen[conf_index],
         print("  skip seen");
         next());
      seen[conf_index] = 1;

      for(p=1,#perms_vector,
         my(new_conf       = conf_permute(conf,perms_vector[p]),
            new_conf_index = conf_to_index(new_conf));
         print("  new conf ",conf_string(new_conf),"  ",new_conf_index);
         m[new_conf_index,conf_index]++;
         m_lr[conf_index,p] = new_conf_index;
         pending_last++;
         pending[pending_last] = new_conf;
      ));
